<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>ExecuteOOTrafo xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/modellibs/core/transformations/ExecuteOOTrafo.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.modellibs.core.transformations;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.CodeGenOptions;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.PortKind;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.extensions.IOOTrafo;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.extensions.OOTrafo;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationException;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.m2minterfaces.IM2MTrafoCDP;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.m2minterfaces.IM2MTrafoElem;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.ApplyRecursive;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.transformations.TransformationContext;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.profile.Transformation.M2MTrafo;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.StereotypeUtil;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Connector;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.EncapsulatedClassifier;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.StructuredClassifier;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/modellibs/core/transformations/ExecuteOOTrafo.html">ExecuteOOTrafo</a> <strong class="jxr_keyword">implements</strong> IM2MTrafoCDP {
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <em class="jxr_javadoccomment">	 * Add OO elements that correspond to ports and connectors</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/modellibs/core/transformations/ExecuteOOTrafo.html">AddOOElements</a> <strong class="jxr_keyword">implements</strong> IM2MTrafoElem {
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  		<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/modellibs/core/transformations/ExecuteOOTrafo.html">AddOOElements</a>(IOOTrafo ooTrafo) {
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  			<strong class="jxr_keyword">this</strong>.ooTrafo = ooTrafo;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  		}
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  		
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  		@Override
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> transformElement(M2MTrafo trafo, Element element) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  			<strong class="jxr_keyword">if</strong> (element instanceof Class) {
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  				Class implementation = (Class) element;
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  				<em class="jxr_comment">// do not apply transformation to port-kinds</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  				<strong class="jxr_keyword">if</strong> (!StereotypeUtil.isApplied(implementation, PortKind.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  					ooTrafo.addPortOperations(implementation);
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  					ooTrafo.addConnectionOperation(implementation);
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  					ooTrafo.transformParts(implementation);
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  				}
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  			}
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		}
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  		IOOTrafo ooTrafo;
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  	}
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment">	 * Delete connectors and ports</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment">	 * Removal is not done after all additions and not after the addition of a single element.</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">	 * Otherwise it would be possible that inherited ports have already been removed.</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/modellibs/core/transformations/ExecuteOOTrafo.html">RemoveComponentElements</a> <strong class="jxr_keyword">implements</strong> IM2MTrafoElem {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  		
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		@Override
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> transformElement(M2MTrafo trafo, Element element) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  			<strong class="jxr_keyword">if</strong> (element instanceof StructuredClassifier) {
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  				removeConnectors((StructuredClassifier) element);
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			}
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  			<strong class="jxr_keyword">if</strong> (element instanceof EncapsulatedClassifier) {
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  				removePorts((EncapsulatedClassifier) element);
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  			}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  		}
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  		<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  <em class="jxr_javadoccomment">		 * Remove connectors from a structured classifier (in most cases a class)</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  <em class="jxr_javadoccomment">		 * </em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">		 * @param implementation</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">		 *            A component</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">		 */</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> removeConnectors(StructuredClassifier implementation) {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  			EList&lt;Connector&gt; connectors = <strong class="jxr_keyword">new</strong> BasicEList&lt;Connector&gt;();
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  			connectors.addAll(implementation.getOwnedConnectors());
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  			<strong class="jxr_keyword">for</strong> (Connector connector : connectors) {
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  				connector.destroy();
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  			}
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		}
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_javadoccomment">		 * Remove ports from a from an encapsulated classifier (in most</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  <em class="jxr_javadoccomment">		 * cases a class)</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">		 * </em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> <em class="jxr_javadoccomment">		 * @param implementation</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> <em class="jxr_javadoccomment">		 *            A component</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> <em class="jxr_javadoccomment">		 */</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> removePorts(EncapsulatedClassifier implementation) {
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 			EList&lt;Port&gt; portListCopy = <strong class="jxr_keyword">new</strong> BasicEList&lt;Port&gt;();
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 			portListCopy.addAll(implementation.getOwnedPorts());
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 			<em class="jxr_comment">// avoid dangling references by calling destroy on the port list</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			<strong class="jxr_keyword">for</strong> (Port port : portListCopy) {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 				port.destroy();
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 			}
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		}
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 	}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 	
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> <em class="jxr_javadoccomment">	 * Determine the component to OO language. The stereotype CodeGenOptions</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> <em class="jxr_javadoccomment">	 * (which could be on any owning package) is evaluated.</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> <em class="jxr_javadoccomment">	 * @param pkg</em>
<a class="jxr_linenumber" name="L119" href="#L119">119</a> <em class="jxr_javadoccomment">	 *            a classifier</em>
<a class="jxr_linenumber" name="L120" href="#L120">120</a> <em class="jxr_javadoccomment">	 * @return the programming language</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String getOOTransformationFromPackage(Package pkg) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		CodeGenOptions codeGenOpt = UMLUtil.getStereotypeApplication(pkg, CodeGenOptions.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		<strong class="jxr_keyword">if</strong> ((codeGenOpt != <strong class="jxr_keyword">null</strong>) &amp;&amp; (codeGenOpt.getCompToOOmapping() != <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 			<strong class="jxr_keyword">return</strong> codeGenOpt.getCompToOOmapping().getBase_Class().getName();
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		}
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		}
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 	}
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 
<a class="jxr_linenumber" name="L132" href="#L132">132</a>     
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L134" href="#L134">134</a> <em class="jxr_javadoccomment">	 * Transform a component model into an object oriented model.</em>
<a class="jxr_linenumber" name="L135" href="#L135">135</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 	@Override
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> applyTrafo(M2MTrafo trafo, Package deploymentPlan) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		String ooTransformation = getOOTransformationFromPackage(TransformationContext.current.modelRoot);
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		<strong class="jxr_keyword">if</strong> (ooTransformation == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 			<em class="jxr_comment">// default OO transformation</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 			ooTransformation = <span class="jxr_string">"StaticCpp"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 		}
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 		IOOTrafo ooTrafo = OOTrafo.getOOTrafo(ooTransformation);
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 		ooTrafo.init(TransformationContext.current.copier, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 		ApplyRecursive add = <strong class="jxr_keyword">new</strong> ApplyRecursive(trafo, <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/modellibs/core/transformations/ExecuteOOTrafo.html">AddOOElements</a>(ooTrafo));
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 		ApplyRecursive remove = <strong class="jxr_keyword">new</strong> ApplyRecursive(trafo, <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/modellibs/core/transformations/ExecuteOOTrafo.html">RemoveComponentElements</a>());
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 		add.applyRecursive(TransformationContext.current.modelRoot);
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 		remove.applyRecursive(TransformationContext.current.modelRoot);
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 		<em class="jxr_comment">// complete access operations?</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 	}
<a class="jxr_linenumber" name="L151" href="#L151">151</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
